'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var language = require('@codemirror/language');
var haskell = require('@codemirror/legacy-modes/mode/haskell');

const tidalLanguage = Object.assign(Object.assign({}, haskell.haskell), { name: "tidal", languageData: Object.assign(Object.assign({}, haskell.haskell.languageData), { closeBrackets: { brackets: ["(", "[", "{", "<", '"'], before: ')]}>"' } }) });

function indentation() {
    return language.indentService.of((context, pos) => {
        let { text, from } = context.lineAt(pos, -1);
        let parse = text.slice(0, pos - from).match(/^([^$#]+)\$.*/);
        if (parse) {
            return Math.min(parse[1].length, 8);
        }
        else {
            return 0;
        }
    });
}

function tidal() {
    return [indentation(), language.StreamLanguage.define(tidalLanguage)];
}

exports.tidal = tidal;
