import { indentService, StreamLanguage } from '@codemirror/language';
import { haskell } from '@codemirror/legacy-modes/mode/haskell';

const tidalLanguage = Object.assign(Object.assign({}, haskell), { name: "tidal", languageData: Object.assign(Object.assign({}, haskell.languageData), { closeBrackets: { brackets: ["(", "[", "{", "<", '"'], before: ')]}>"' } }) });

function indentation() {
    return indentService.of((context, pos) => {
        let { text, from } = context.lineAt(pos, -1);
        let parse = text.slice(0, pos - from).match(/^([^$#]+)\$.*/);
        if (parse) {
            return Math.min(parse[1].length, 8);
        }
        else {
            return 0;
        }
    });
}

function tidal() {
    return [indentation(), StreamLanguage.define(tidalLanguage)];
}

export { tidal };
